<template>
  <q-card
    flat
    class="rounded-borders-10"
    :class="{
      'q-pa-sm': screenWidth >= 768 && screenWidth <= 899,
      'q-pa-md': screenWidth >= 900,
    }"
  >
    <q-card-section>
      <div class="row">
        <div class="col-6">
          <label class="title-headline"> Basic Information </label>
        </div>

        <div class="col-6" align="right">
          <q-btn
            unelevated
            size="md"
            icon="eva-edit-outline"
            class="btn-edit text-grey-6"
            @click="
              showBasicInfo(userStore.userDetails, addressStore.address),
                (showEditDialog = true)
            "
          />
        </div>
      </div>
    </q-card-section>

    <q-card-section>
      <div class="row">
        <div class="col flex justify-center">
          <div class="image-avatar">
            <!-- <q-avatar size="100px">
              <img
                :src="
                  userStore.userDetails.profile_picture_url
                    ? userStore.userDetails.profile_picture_url
                    : '~assets/default.png'
                "
              />
            </q-avatar> -->
            <custom-avatar
              :photoUrl="userStore.userDetails.profile_picture_url"
              :name="userStore.userDetails.first_name"
              :userType="userStore.userDetails.user_type"
              size="100px"
              fontSize="35px"
            />
            <div class="image-btn">
              <q-btn
                class="btn--shade-1 btn-edit text-white q-pa-lg"
                icon="eva-plus-outline"
                style="border: 5px solid #fff"
                @click="showUploadPicture(), (showUploadProfileDialog = true)"
              />
            </div>
          </div>
        </div>
      </div>
    </q-card-section>

    <q-card-section>
      <div class="row">
        <div class="col-5">
          <label
            class="text-caption text-weight-bold text-grey-6"
            style="font-size: 11px"
          >
            FIRST NAME
          </label>
        </div>

        <div class="col text-dark">
          <p class="title-6">
            {{
              userStore.userDetails.first_name
                ? userStore.userDetails.first_name
                : "-"
            }}
          </p>
        </div>
      </div>

      <div class="row">
        <div class="col-5">
          <label
            class="text-caption text-weight-bold text-grey-6"
            style="font-size: 11px"
          >
            LAST NAME
          </label>
        </div>

        <div class="col text-dark">
          <p class="title-6">
            {{
              userStore.userDetails.last_name
                ? userStore.userDetails.last_name
                : "-"
            }}
          </p>
        </div>
      </div>

      <div class="row">
        <div class="col-5">
          <label
            class="text-caption text-weight-bold text-grey-6"
            style="font-size: 11px"
          >
            MIDDLE NAME
          </label>
        </div>

        <div class="col text-dark">
          <p class="title-6">
            {{
              userStore.userDetails.middle_name
                ? userStore.userDetails.middle_name
                : "-"
            }}
          </p>
        </div>
      </div>

      <div class="row">
        <div class="col-5">
          <label
            class="text-caption text-weight-bold text-grey-6"
            style="font-size: 11px"
          >
            EMAIL
          </label>
        </div>

        <div class="col text-dark">
          <p class="title-6" style="overflow: hidden; text-overflow: ellipsis">
            {{
              userStore.userDetails.email ? userStore.userDetails.email : "-"
            }}
          </p>
        </div>
      </div>

      <div class="row">
        <div class="col-5">
          <label
            class="text-caption text-weight-bold text-grey-6"
            style="font-size: 11px"
          >
            MOBILE NUMBER
          </label>
        </div>

        <div class="col text-dark">
          <p class="title-6">
            {{
              userStore.userDetails.mobile_number
                ? userStore.userDetails.mobile_number
                : "-"
            }}
          </p>
        </div>
      </div>

      <div class="row">
        <div class="col-5">
          <label
            class="text-caption text-weight-bold text-grey-6"
            style="font-size: 11px"
          >
            BIRTHDATE
          </label>
        </div>

        <div class="col text-dark">
          <p class="title-6">
            {{
              userStore.userDetails.birthdate
                ? userStore.userDetails.birthdate
                : "-"
            }}
          </p>
        </div>
      </div>

      <div class="row">
        <div class="col-5">
          <label
            class="text-caption text-weight-bold text-grey-6"
            style="font-size: 11px"
          >
            ADDRESS (BRGY)
          </label>
        </div>

        <div class="col text-dark">
          <p
            v-for="(barangay, key) in referenceStore.barangays.filter(
              (item) => item.id === addressStore.address.barangay_id
            )"
            :key="key"
            class="title-6"
          >
            {{ barangay.name }}
          </p>
        </div>
      </div>

      <div class="row">
        <div class="col-5">
          <label
            class="text-caption text-weight-bold text-grey-6"
            style="font-size: 11px"
          >
            ADDRESS (CITY)
          </label>
        </div>

        <div class="col text-dark">
          <p
            v-for="(city, key) in referenceStore.cities.filter(
              (item) => item.id === addressStore.address.city_id
            )"
            :key="key"
            class="title-6"
          >
            {{ city.name }}
          </p>
        </div>
      </div>
    </q-card-section>
  </q-card>

  <!-- DIALOG: EDIT BASIC INFORMATION  -->
  <q-dialog
    v-model="showEditDialog"
    persistent
    @hide="showEditDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1300px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10">Edit Basic Information</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="editDetails(form)">
          <div class="row">
            <div class="col q-mr-lg" :class="{ 'col-12': $q.screen.lt.sm }">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-6"
                  >FIRST NAME <span class="text-negative">*</span></label
                >
                <q-input
                  v-model="form.first_name"
                  dense
                  outlined
                  class="q-mt-sm"
                  :rules="[validations.requiredField]"
                />
              </div>
            </div>

            <div class="col q-mr-lg" :class="{ 'col-12': $q.screen.lt.sm }">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-6"
                  >MIDDLE NAME</label
                >
                <q-input
                  v-model="form.middle_name"
                  dense
                  outlined
                  class="q-mt-sm"
                />
              </div>
            </div>

            <div class="col" :class="{ 'col-12': $q.screen.lt.sm }">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-6"
                  >LAST NAME <span class="text-negative">*</span></label
                >
                <q-input
                  v-model="form.last_name"
                  dense
                  outlined
                  class="q-mt-sm"
                  :rules="[validations.requiredField]"
                />
              </div>
            </div>
          </div>

          <div class="row">
            <div class="col q-mr-lg" :class="{ 'col-12': $q.screen.lt.sm }">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-6"
                  >DATE OF BIRTH <span class="text-negative">*</span></label
                >
                <q-input
                  dense
                  outlined
                  v-model="form.birthdate"
                  class="q-mt-sm"
                  mask="date"
                  :rules="[validations.requiredField]"
                >
                  <template v-slot:append>
                    <q-icon name="eva-calendar-outline" class="cursor-pointer">
                      <q-popup-proxy
                        cover
                        transition-show="scale"
                        transition-hide="scale"
                      >
                        <q-date
                          v-model="form.birthdate"
                          navigation-max-year-month="2008/12"
                          default-year-month="2008/01"
                        >
                          <div class="row items-center justify-end">
                            <q-btn
                              v-close-popup
                              label="Close"
                              color="primary"
                              flat
                            />
                          </div>
                        </q-date>
                      </q-popup-proxy>
                    </q-icon>
                  </template>
                </q-input>
              </div>
            </div>

            <div class="col q-mr-lg" :class="{ 'col-12': $q.screen.lt.sm }">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-6"
                  >GENDER <span class="text-negative">*</span></label
                >

                <q-select
                  v-model="form.gender"
                  :options="GENDERS"
                  map-options
                  emit-value
                  option-label="name"
                  option-value="id"
                  dense
                  outlined
                  class="q-mt-sm"
                  :rules="[validations.requiredField]"
                />
              </div>
            </div>

            <div class="col" :class="{ 'col-12': $q.screen.lt.sm }">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-6"
                  >MOBILE NUMBER <span class="text-negative">*</span></label
                >
                <q-input
                  v-model="form.mobile_number"
                  dense
                  outlined
                  class="q-mt-sm"
                  :rules="[validations.requiredField]"
                  v-on:keyup="formatMobileNumber(form.mobile_number)"
                  placeholder="xxx-xxx-xxxx"
                  maxlength="12"
                >
                  <template v-slot:prepend>
                    <span class="title-7">(+63)</span>
                  </template>
                </q-input>
              </div>
            </div>
          </div>

          <div class="row">
            <div class="col q-mr-lg" :class="{ 'col-12': $q.screen.lt.sm }">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-6"
                  >EMAIL <span class="text-negative">*</span></label
                >
                <q-input
                  v-model="form.email"
                  dense
                  outlined
                  class="q-mt-sm"
                  :rules="[validations.requiredField, validations.emailFormat]"
                />
              </div>
            </div>

            <div class="col q-mr-lg" :class="{ 'col-12': $q.screen.lt.sm }">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-6"
                  >ADDRESS (CITY) <span class="text-negative">*</span></label
                >
                <q-select
                  v-model="form.city_id"
                  :options="cityOptions"
                  use-input
                  hide-selected
                  fill-input
                  input-debounce="0"
                  option-label="name"
                  option-value="id"
                  map-options
                  emit-value
                  dense
                  outlined
                  class="q-mt-sm"
                  @filter="filterCityOptions"
                  :rules="[validations.requiredField]"
                >
                  <template v-slot:no-option>
                    <q-item>
                      <q-item-section class="text-grey-6">
                        No results
                      </q-item-section>
                    </q-item>
                  </template>
                </q-select>
              </div>
            </div>

            <div class="col" :class="{ 'col-12': $q.screen.lt.sm }">
              <div class="q-py-xs">
                <label class="text-caption text-weight-bold text-grey-6"
                  >ADDRESS (BARANGAY)
                  <span class="text-negative">*</span>
                </label>

                <q-select
                  v-model="form.barangay_id"
                  :options="barangayOptions"
                  use-input
                  hide-selected
                  fill-input
                  input-debounce="0"
                  option-label="name"
                  option-value="id"
                  map-options
                  emit-value
                  dense
                  outlined
                  class="q-mt-sm"
                  @filter="filterBarangayOptions"
                  :rules="[validations.requiredField]"
                >
                  <template v-slot:no-option>
                    <q-item>
                      <q-item-section class="text-grey-6">
                        No results
                      </q-item-section>
                    </q-item>
                  </template>
                </q-select>
              </div>
            </div>
          </div>

          <div class="q-mt-xl flex justify-center">
            <q-btn
              unelevated
              class="btn--shade-1 btn-lg text-white"
              label="SUBMIT"
              type="submit"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- DIALOG: UPLOAD PROFILE PICTURE -->
  <q-dialog
    v-model="showUploadProfileDialog"
    persistent
    @hide="showUploadProfileDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 600px; max-width: 80vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-dark">Upload Profile Photo</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <div>
          <q-file
            outlined
            v-model="profileForm.profile_picture"
            max-file-size="5242880"
            :rules="[validations.requiredField]"
            :filter="checkFileTypeProfile"
            @rejected="onRejected"
          >
            <template v-slot:prepend>
              <q-icon name="eva-attach-outline" />
            </template>
          </q-file>
          <p id="error" class="q-field_messages text-negative q-pa-sm">
            {{ errorMessage }}
          </p>
        </div>
      </q-card-section>

      <div class="q-my-md" align="center">
        <q-btn
          unelevated
          label="UPLOAD"
          class="btn--shade-1 btn-lg text-white q-mr-sm"
          :loading="loading"
          @click="confirmUploadProfile(profileForm)"
        />
      </div>
    </q-card>
  </q-dialog>
</template>

<script>
import { LocalStorage } from "quasar";
import { defineComponent, ref, reactive, onMounted, onUnmounted } from "vue";
import { useUser } from "src/layouts/portals/store/user";
import { useAddress } from "../../store/address";
import { requiredField, emailFormat } from "src/hooks/validations";
// import { useReference } from "../../store/reference";
import { useReference } from "src/modules/auth/store/reference";
import { GENDERS } from "src/constants";
import useJobseekerHook from "../../hooks/jobseekerHook";
import CustomAvatar from "src/components/CustomAvatar.vue";

export default defineComponent({
  components: { CustomAvatar },
  setup() {
    const userStore = useUser();
    const { getBasicInfo } = userStore;

    const addressStore = useAddress();
    const { showAddress } = addressStore;

    const referenceStore = useReference();
    const { getCities, getBarangays } = referenceStore;

    const screenWidth = ref(0);

    const { loading, doUpdateBasicInfo, doUpdateAddress, doUpdatePhoto } =
      useJobseekerHook();
    const USER_ID = ref(null);
    const ADDRESS_ID = ref(null);
    const showEditDialog = ref(false);
    const showUploadProfileDialog = ref(false);
    const isError = ref(false);
    const errorMessage = ref("");
    const cityOptions = ref(referenceStore.cities);
    const barangayOptions = ref(referenceStore.barangays);

    const form = reactive({
      first_name: "",
      middle_name: "",
      last_name: "",
      birthdate: "",
      gender: "",
      email: "",
      mobile_number: "",
      city_id: "",
      barangay_id: "",
    });

    const profileForm = reactive({
      profile_picture: null,
      _method: "PUT",
    });

    const formatMobileNumber = (number) => {
      let formattedNumber = number
        .replace(/\D+/g, "")
        .replace(/(\d{3})(\d{3})(\d{3})/, "$1-$2-$3");
      form.mobile_number = formattedNumber;
    };

    const fetchUserDetails = async () => {
      USER_ID.value = LocalStorage.getItem("auth").id;
      ADDRESS_ID.value = LocalStorage.getItem("auth").address.id;

      await getBasicInfo(USER_ID.value);
      await showAddress(ADDRESS_ID.value);
      await getCities();
      await getBarangays();
    };

    const showBasicInfo = (info, address) => {
      form.first_name = info.first_name;
      form.middle_name = info.middle_name;
      form.last_name = info.last_name;
      form.birthdate = info.birthdate;
      form.gender = info.gender;
      form.email = info.email;
      form.mobile_number = info.mobile_number;
      form.city_id = address.city_id;
      form.barangay_id = address.barangay_id;
    };

    const editDetails = async (form) => {
      USER_ID.value = LocalStorage.getItem("auth").id;

      await doUpdateBasicInfo(USER_ID.value, form);
      await doUpdateAddress(USER_ID.value, form);
      showEditDialog.value = false;
      // fetchUserDetails();
      await getBasicInfo(USER_ID.value);
      ADDRESS_ID.value = LocalStorage.getItem("auth").address.id;
      await showAddress(ADDRESS_ID.value);
    };

    const showUploadPicture = () => {
      profileForm.profile_picture = null;
    };

    const confirmUploadProfile = async (form) => {
      USER_ID.value = LocalStorage.getItem("auth").id;
      const formData = new FormData();
      formData.append(
        "profile_picture",
        form.profile_picture,
        form.profile_picture.name
      );
      formData.append("_method", form._method);

      await doUpdatePhoto(USER_ID.value, formData);
      showUploadProfileDialog.value = false;
      // fetchUserDetails();
      await getBasicInfo(USER_ID.value);
      ADDRESS_ID.value = LocalStorage.getItem("auth").address.id;
      await showAddress(ADDRESS_ID.value);
    };

    onMounted(() => {
      window.addEventListener("resize", screenResize);
    });

    onUnmounted(() => {
      window.removeEventListener("resize", screenResize);
    });

    const screenResize = () => {
      screenWidth.value = window.innerWidth;
    };

    screenResize();

    fetchUserDetails();

    return {
      userStore,
      addressStore,
      referenceStore,
      USER_ID,
      ADDRESS_ID,
      form,
      profileForm,
      showUploadPicture,
      showEditDialog,
      showUploadProfileDialog,
      loading,
      GENDERS,
      cityOptions,
      barangayOptions,
      validations: {
        requiredField,
        emailFormat,
      },
      checkFileTypeProfile(files) {
        return files.filter(
          (file) =>
            file.type === "image/jpg" ||
            file.type === "image/png" ||
            file.type === "image/jpeg"
        );
      },
      onRejected(files) {
        for (let x = 0; x < files.length; x++) {
          const file = files[x];

          if (file.failedPropValidation === "max-file-size") {
            isError.value = true;
            errorMessage.value = "File size should not be greater than 5MB";
          } else if (file.failedPropValidation === "filter") {
            isError.value = true;
            errorMessage.value = "The file type uploaded is not supported";
          } else {
            isError.value = false;
            errorMessage.value = "";
          }
        }
      },
      formatMobileNumber,
      editDetails,
      showBasicInfo,
      confirmUploadProfile,
      filterCityOptions(val, update, abort) {
        update(() => {
          const needle = val.toLowerCase();
          cityOptions.value = referenceStore.cities.filter(
            (v) => v.name.toLowerCase().indexOf(needle) > -1
          );
        });
      },
      filterBarangayOptions(val, update, abort) {
        update(() => {
          const needle = val.toLowerCase();
          barangayOptions.value = referenceStore.barangays.filter(
            (v) => v.name.toLowerCase().indexOf(needle) > -1
          );
        });
      },
      screenResize,
      screenWidth,
    };
  },
});
</script>

<style lang="scss" scoped>
.btn-edit {
  border-radius: 50px !important;
  padding: 5px !important;
}
.image-container {
  width: 111px;
  height: 111px;
  display: block;
}

.image-avatar {
  margin: auto;
  position: relative;
}
.image-btn {
  width: 35px;
  height: 35px;
  position: absolute;
  right: -3.5px;
  bottom: -4px;
}
</style>
